;  
	LIST p=16f876A		

	include <p16f876A.inc>
	__config 3D39h

OA			= 0					;   
OC			= 1					;   
DISPLAY		= OC				; 				

#define		TERMO_1	PORTA,1		; 

#define 	KEY	PORTC,5		;   

;  

ANALIZ_U	EQU 	20h		;  

COUNT		EQU 	2Ah

TM1    		EQU 	2Dh       	;   2 
TM2    		EQU 	2Eh       		
TM3    		EQU 	2Fh   

FLAG		EQU 	22h  		;:  0 -  ( ),
					;1- ,  2 - ,

W_TEMP		EQU 	23h  		
STATUS_TEMP	EQU 	24h  	
PCLATH_TEMP	EQU 	25h
FSR_TEMP	EQU 	26h  

BUF_1		EQU 	42h  		;   
BUF_2		EQU 	43h
BUF_3		EQU 	44h  
BUF_4		EQU 	45h 
BUF_5		EQU 	46h  
NumH		EQU 	48h 
NumL		EQU 	49h  

LSB		equ    	31h		; 
MSB		equ     32h		;
_N 		equ     33h		
I_BYTE  	equ     34h		
LOOP1		equ 	35h
LSBT		equ 	36h
MSBT		equ 	37h
O_BYTE		equ     38h	

TEST_IND	equ     39h	
TEST_COUNT	equ     3Ah	
;**********************************************************************************************************************************
       	ORG 0 					; .
       	GOTO    BEGIN 
;**********************************************************************************************************************************
;
;
	ORG	0x04			 ;  

	MOVWF 	W_TEMP   		;     
      	SWAPF 	STATUS,W
      	CLRF 	STATUS
      	MOVWF 	STATUS_TEMP
      	MOVF 	PCLATH , W
      	MOVWF 	PCLATH_TEMP

	BTFSC	INTCON,2		;      TMR0
	GOTO	INDIK_OUT		;   


RECONSTR

	MOVF 	PCLATH_TEMP,W		;     
     	MOVWF 	PCLATH
     	SWAPF 	STATUS_TEMP,W
     	MOVWF 	STATUS
     	SWAPF 	W_TEMP,F
     	SWAPF 	W_TEMP,W

	RETFIE

;**********************************************************************************************************************************
;  
;**********************************************************************************************************************************
BEGIN   

	CLRF   	PORTA         		;  PORTA
 IF  DISPLAY == OA
   	MOVLW  	b'11111111'
   	MOVWF  	PORTB         		;  PORTB
  	CLRF   	PORTC   
 ELse
   	CLRF  	PORTB         		;  PORTB
   	MOVLW  	b'11111111'
   	MOVWF  	PORTC         		;  PORTB
 endif

	BCF    	STATUS,RP1       	;  1
	BSF    	STATUS,RP0

;	MOVLW  	0x06
	MOVLW 	B'00001110' 
	MOVWF	ADCON1
	MOVLW	b'10000011'
	MOVWF	OPTION_REG

 	MOVLW  	b'00000001'         ;p B'0000001'  pp W
 	MOVWF  	TRISA    
      	
   	MOVLW  	b'00000000'         ;p B'00000000'  pp W
   	MOVWF  	TRISB         		;      
    
	MOVLW  	b'00100000'         ;p B'00000000'  pp 
   	MOVWF  	TRISC         		;
	BCF    	STATUS,RP0		    ;  0

	MOVLW	b'10100000'
	MOVWF	INTCON

	CLRF	BUF_1			; 
	CLRF	BUF_2
	CLRF	BUF_3
	CLRF	BUF_4
	CLRF	BUF_5
	CLRF	NumL
	CLRF	NumH

	CLRF	LSB
	CLRF	MSB
	CLRF	_N 					
	CLRF	I_BYTE  
	CLRF	LOOP1		
	CLRF	LSBT			
	CLRF	MSBT			
	CLRF	O_BYTE		
	CLRF	FLAG
	CLRF	TEST_IND
	
;=========== 

	BCF	INTCON,5

	BCF 	FLAG,0			;    
    CALL   	START_DS    		;  
    CALL  	READ_T      		;                    ;         

 IF  DISPLAY == OA
;     
	MOVLW	b'00001111'
	MOVWF	PORTC

	MOVLW	b'10000000'		; 
	MOVWF	PORTB
 ELse
;     
	MOVLW	b'00000000'
	MOVWF	PORTC

	MOVLW	b'01111111'		; 
	MOVWF	PORTB
 endif
;
	CALL	DELAY_1S

;---------------------------

;	GOTO	TERMOMETR



;===========    ()

TERMOMETR
	BSF	INTCON,5

	BTFSC	KEY
	GOTO	NEXT_TERM
	CALL	Delay_001
	BTFSC	KEY
	GOTO	NEXT_TERM
	BTFSS	KEY
	GOTO	$-1
	BCF	FLAG,1			;      
	GOTO	VOLTMETR

NEXT_TERM
	BSF	FLAG,1			;     

;	BSF    	STATUS,RP0		;  1
;	MOVLW  	0x06
;	MOVWF	ADCON1
;	BCF    	STATUS,RP0		;  0

	BCF 	FLAG,0			;    
        CALL   	START_DS    		;  
        CALL  	READ_T      		;                    ;         
           	
IZM_TERMO
	movfw  	LSB        		;    LSB                
        andlw  	h'F0'                                       
        movwf  	LSBT       		;    LSBT                     
        swapf  	LSBT,F     		;                          
        movfw  	MSB         		;    MSB               
       	andlw  	h'0F'                                           
       	movwf  	MSBT        		;    MSBT                  
       	swapf  	MSBT,F     		;                         
       	movfw  	MSBT        		;    LSBT,               
        iorwf  	LSBT,F       		;       1                                       		
        btfss	LSBT,7        		;  ?			
        GOTO  	OUT_DEC
        comf   	LSBT,f       		;     -
        incf  	LSBT,f          	;     
        bsf   	FLAG,0      	;    

OUT_DEC
	MOVF	LSBT,0			;   (   )
	MOVWF 	NumL	
	CALL	HEX2DEC

	GOTO	TERMOMETR

;-------------------------------------------------------------------------------
           ;         #1
;-------------------------------------------------------------------------------
READ_T
       	CALL	INIT
	MOVLW	0xCC			;   
	MOVWF	O_BYTE
	CALL	OUT_BYTE
	MOVLW	0xBE			;    
	MOVWF	O_BYTE
	CALL	OUT_BYTE                ;  
	CALL 	IN_BYTE
	MOVWF	LSB     		;    
	CALL 	IN_BYTE
	MOVWF	MSB     		;    
	CALL   	PIN_LO          	;    
       	RETURN
;-------------------------------------------------------------------------------
       ;      
;--------------------------------------------------------------------------------------- 
START_DS
	CALL	INIT
	MOVLW	0xCC			;   
	MOVWF	O_BYTE
       	CALL	OUT_BYTE
	MOVLW	0x44			;   
	MOVWF	O_BYTE
	CALL	OUT_BYTE
      	RETURN
;-------------------------------------------------------------------------------
                     ;     1-Wire
;-----------------------------------------------------------------------------------
INIT:
        CALL 	PIN_HI
        CALL  	PIN_LO
        MOVLW  	.50              	;  500  
        CALL 	DELAY_10USEC
        CALL   	PIN_HI
        MOVLW  	.50             	;  500 
        CALL 	DELAY_10USEC
        RETURN
;------------------------------------------------------------------------------
IN_BYTE: 
 					;    W 
        MOVLW  	.8
        MOVWF  	_N
        CLRF   	I_BYTE
IN_BYTE_1:
        CALL 	PIN_LO
        NOP
        CALL 	PIN_HI
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
	BTFSS 	TERMO_1
        BCF 	STATUS, C  
	BTFSC	 TERMO_1
        BSF 	STATUS, C 
        RRF 	I_BYTE, F
        MOVLW 	.6              
        CALL  	DELAY_10USEC
        DECFSZ 	_N, F
        GOTO    IN_BYTE_1
        MOVFW   I_BYTE         		 ;    W
        RETURN
 ;------------------------------------------
OUT_BYTE:
        MOVLW  	.8
        MOVWF  	_N
OUT_BYTE_1:
        RRF 	O_BYTE, F
        BTFSS  	STATUS, C
        GOTO  	OUT_0
        GOTO  	OUT_1
OUT_BYTE_2:
        DECFSZ 	_N, F
        GOTO   	OUT_BYTE_1
        RETURN
;-------------------------------------------
OUT_0:
        CALL	PIN_LO          
        MOVLW  	.6              
        CALL  	DELAY_10USEC
        CALL   	PIN_HI
        GOTO   	OUT_BYTE_2
OUT_1:
        CALL   	PIN_LO          
        CALL  	PIN_HI
        MOVLW 	.6
        CALL 	DELAY_10USEC
        GOTO    OUT_BYTE_2
;-----------------------------------------

PIN_HI:
        BSF  	STATUS, RP0    		;   -
        movlw  	b'00001011'
        movwf  	TRISA
        BCF   	STATUS, RP0
        RETURN
;---------------------------------------
PIN_LO:
	BCF   	TERMO_1 		;   -------
       	BSF 	STATUS, RP0
        movlw  	b'00001001'
   	movwf  	TRISA  
  	BCF   	STATUS, RP0
	RETURN
;---------------------------------------
DELAY_10USEC: 
					;   W * 10 
        MOVWF 	LOOP1
DELAY_10USEC_1:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ 	LOOP1, F
        GOTO 	DELAY_10USEC_1
        RETURN

;==================================================================
;==========================================================
SEGDATA 
 IF  DISPLAY == OA
;     
	ADDWF	PCL,F
	RETLW	b'11000000'		; 0
	RETLW	b'11111001'		; 1
	RETLW	b'10100100'		; 2
	RETLW	b'10110000'		; 3
	RETLW	b'10011001'		; 4
	RETLW	b'10010010'		; 5
	RETLW	b'10000010'		; 6
	RETLW	b'11111000'		; 7
	RETLW	b'10000000'		; 8
	RETLW	b'10010000'		; 9
        ;    16 ,   
        ;       wreg  
        retlw   0
        retlw   0
        retlw   0
        retlw   0
        retlw   0
        retlw   0
 ELse
;     
	ADDWF	PCL,F
	RETLW	b'00111111'		; 0 b'00111111'
	RETLW	b'00000110'		; 1 b'00000110'
	RETLW	b'01011011'		; 2 b'01011011'
	RETLW	b'01001111'		; 3 b'01001111'
	RETLW	b'01100110'		; 4 b'01100110'
	RETLW	b'01101101'		; 5 b'01101101'
	RETLW	b'01111101'		; 6 b'01111101'
	RETLW	b'00000111'		; 7 b'00000111'
	RETLW	b'01111111'		; 8 b'01111111'
	RETLW	b'01101111'		; 9 b'01101111'
        ;    16 ,   
        ;       wreg  
        retlw   0
        retlw   0
        retlw   0
        retlw   0
        retlw   0
        retlw   0
 endif

	
;=================================================================
INDIK_OUT
	BCF 	INTCON,5
 IF  DISPLAY == OA
;     
   	MOVLW  	b'11111111'            	;
   	MOVWF  	PORTB         		;  PORTB
	MOVLW  	b'00000100' 		;   
	MOVWF	PORTC
 ELse
;     
   	MOVLW  	0
   	MOVWF  	PORTB         		;  PORTB
	MOVLW  	b'00001011' 		;   
	MOVWF	PORTC
 endif

	MOVF	BUF_5,0
	CALL	SEGDATA 
	MOVWF	PORTB
	CALL	Delay_001
	BTFSS  	FLAG,1			;    
	GOTO	IND_DES			;      

	MOVF	BUF_3,0			;   -         100-109
	SUBLW	.0
	BTFSS	STATUS,Z
	GOTO	IND_DES

	MOVF	BUF_4,0			;        
	SUBLW	.0
	BTFSS	STATUS,Z
	GOTO	IND_DES			;   -     

	BTFSS	FLAG,0			;    
	GOTO	NEXT_IND		;  , Ĩ  

 IF  DISPLAY == OA
;     
	MOVLW  	b'00000010' 
	MOVWF	PORTC			;  -      
	MOVLW   b'10111111' 		; 
	MOVWF	PORTB
 ELse
;     
	MOVLW  	b'00001101' 
	MOVWF	PORTC			;  -      
	MOVLW   b'01000000' 		; 
	MOVWF	PORTB
 endif

	BCF	FLAG,0
	GOTO	NEXT_IND		;  Ĩ 

IND_DES
 IF  DISPLAY == OA
;     
   	MOVLW  	b'11111111'       	;
   	MOVWF  	PORTB         		;  PORTB
	MOVLW   b'00000010' 		;   
	MOVWF	PORTC
 ELse
;     
	MOVLW   0
	MOVWF	PORTB
	MOVLW   b'00001101' 		;   
	MOVWF	PORTC				;  -      
 endif

	MOVF	BUF_4,0
	CALL	SEGDATA 
	MOVWF	PORTB
	BTFSC	FLAG,2			;    
 IF  DISPLAY == OA
;     
	BCF 	PORTB,7			;   
 ELse
;     
	BSF 	PORTB,7			;   
 endif

	CALL	Delay_001

	MOVF	BUF_3,0			;    
	SUBLW	.0
	BTFSC	STATUS,Z
	GOTO	ZNAK

 IF  DISPLAY == OA
;     
   	MOVLW  	b'11111111'            	;
   	MOVWF  	PORTB         		;  PORTB

	MOVLW   b'00000001'		;   
	MOVWF	PORTC
 ELse
;     
   	MOVLW  	0
   	MOVWF  	PORTB         		;  PORTB

	MOVLW   b'00001110'		;   
	MOVWF	PORTC
 endif

	MOVF	BUF_3,0			;   
	CALL	SEGDATA 
	MOVWF	PORTB
;	CALL	Delay_001

ZNAK
	BTFSS	FLAG,0			;     
	GOTO	NEXT_IND		;  Ĩ 

 IF  DISPLAY == OA
;     
	MOVLW   b'10111111' 		; 
	MOVWF	PORTB
	MOVLW   b'00000001'		;b'00000001'
	MOVWF	PORTC			;  -      
 ELse
;     
	MOVLW   b'01000000' 
	MOVWF	PORTB
	MOVLW   b'00001110'		;b'00000001'
	MOVWF	PORTC			;  -      
 endif

	BCF	FLAG,0

NEXT_IND				;   / 
	CALL	Delay_001
 IF  DISPLAY == OA
;     
   	MOVLW  	b'11111111'            	;
   	MOVWF  	PORTB         		;  PORTB

	MOVLW   b'00001000' 
	MOVWF	PORTC
 ELse
;     
   	MOVLW  	0
   	MOVWF  	PORTB         		;  PORTB

	MOVLW   b'00000111' 
	MOVWF	PORTC
 endif

	BTFSC	FLAG,2			;    
	GOTO	VOLT			;   

GRADUS 
 IF  DISPLAY == OA
;     
	MOVLW   b'10011100' 		;       -   
	MOVWF	PORTB
	CALL	Delay_001
   	MOVLW  	b'11111111'            	;
   	MOVWF  	PORTB         		;  PORTB
 ELse
;     
	MOVLW   b'01100011' 		;       -   
	MOVWF	PORTB
	CALL	Delay_001
   	MOVLW  	0
   	MOVWF  	PORTB         		;  PORTB
 endif
	GOTO	RECONSTR;

VOLT
 IF  DISPLAY == OA
;     
	MOVLW   b'11100011' 			
	MOVWF	PORTB
	CALL	Delay_001
    MOVLW  	b'11111111'            	;
    MOVWF  	PORTB         		;  PORTB
 ELse
;     
	MOVLW   b'00011100' 		;       -   
	MOVWF	PORTB
	CALL	Delay_001
   	MOVLW  	0
   	MOVWF  	PORTB         		;  PORTB
 endif
	GOTO	RECONSTR;

;==== =============================

VOLTMETR
	BSF	INTCON,5
	BTFSC	KEY
	GOTO	NEXT_VOLTMETR
	CALL	Delay_001
	BTFSC	KEY
	GOTO	NEXT_VOLTMETR
	BTFSS	KEY
	GOTO	$-1
	BCF 	FLAG,2			;  

	GOTO	TERMOMETR

NEXT_VOLTMETR
	BSF 	FLAG,2			;  
	CALL	ADC_U
	MOVF 	ANALIZ_U,0	
	MOVWF 	NumL
	CALL	HEX2DEC

	GOTO	VOLTMETR

;==========================================================



;========================================================

Delay_001
	movlw	0xC7;0xE7
	movwf	TM1
	movlw	0x01;0x04
	movwf	TM2

Delay_0001
	decfsz	TM1, f
	goto	$+2
	decfsz	TM2, f
	goto	Delay_0001
	goto	$+1
	RETURN
;==========================================================

HEX2DEC
	swapf 	NumH,w 
	andlw	0Fh			;           
	addlw 	h'F0'			;          
	movwf 	BUF_2 
	addwf 	BUF_2,f 
	addlw 	h'E2' 
	movwf 	BUF_3
	addlw 	32 
	movwf 	BUF_5 
 	movf 	NumH,w 
 	andlw 	0F		; 
	addwf 	BUF_3,f 
 	addwf 	BUF_3,f 
	addwf 	BUF_5,f 
	addlw 	h'E9' 
	movwf 	BUF_4 
	addwf 	BUF_4,f 
	addwf 	BUF_4,f 
	swapf 	NumL,w 
	andlw 	0F 
	addwf 	BUF_4,f 
	addwf 	BUF_5,f 
	rlf 	BUF_4,f 
 	rlf 	BUF_5,f 
	comf 	BUF_5,f 
	rlf 	BUF_5,f 
	movf 	NumL,w 
	andlw 	0F 
	addwf 	BUF_5,f 
	rlf 	BUF_2,f 
	movlw 	07 
	movwf 	BUF_1
;=======

	MOVLW	.10
	
HEX2DEC_100
	ADDWF	BUF_5,f
	DECF	BUF_4,f
	BTFSS	STATUS,0
	GOTO	HEX2DEC_100
	
HEX2DEC_10
	ADDWF	BUF_4,f
	DECF	BUF_3,f
	BTFSS	STATUS,0
	GOTO	HEX2DEC_10
	
HEX2DEC_1
	ADDWF	BUF_3,f
	DECF	BUF_2,f
	BTFSS	STATUS,0
	GOTO	HEX2DEC_1



HEX2DEC_0
	ADDWF	BUF_2,f
	DECF	BUF_1,f
	BTFSS	STATUS,0
	GOTO	HEX2DEC_0

	CLRF	NumH
	CLRF	NumL

	Return

;===========================================================

ADC_U					;   
;	MOVLW 	B'00001110' 
;	BSF	STATUS,RP0		;  1
;	MOVWF 	ADCON1	
;	BCF	STATUS,RP0		;  0

	CLRF	ANALIZ_U
	MOVLW 	B'00000001' 		;   0 = RA0,   5/4/3 
	MOVWF 	ADCON0

	CALL	DEL_ADC 		; 23 

	BSF 	ADCON0,2		;  
	CALL	DEL_ADC 		; 23 
	BTFSC 	ADCON0,2		;  o 
	GOTO 	$-1

	CLRF	ANALIZ_U
	MOVF	ADRESH,0		;     
	MOVWF 	ANALIZ_U	
	RETURN

;==================================================================

DEL_ADC 				; 23 
	MOVLW	D'7'
	MOVWF	COUNT
CL	
	DECFSZ	COUNT, F
	GOTO	CL
	RETURN

;**********************************************************************************
; ( 1 ) 
;**********************************************************************************
DELAY_1S
	movlw	0x08
	movwf	TM1
	movlw	0x2F
	movwf	TM2
	movlw	0x03
	movwf	TM3
Delay_0
	decfsz	TM1, f
	goto	$+2
	decfsz	TM2, f
	goto	$+2
	decfsz	TM3, f
	goto	Delay_0
	goto	$+1
	nop
	RETURN
;*********************************************************************************

	END
;********************************************************************************	

	
	
	
